import{s as nt,n as at,o as it}from"../chunks/scheduler.182ea377.js";import{S as st,i as dt,g as o,s,p as N,A as lt,h as r,f as t,c as d,j as m,q as x,m as c,k as a,v as n,a as l,r as A,d as z,t as w,u as L}from"../chunks/index.008d68e4.js";import{D as ze}from"../chunks/Docstring.7aec8b85.js";import{I as ae}from"../chunks/IconCopyLink.96bbb92b.js";function mt(Ze){let u,ie,h,C,ee,T,we,O,He="Normalization layers",se,G,Ie="Customized normalization layers for supporting various models in 🤗 Diffusers.",de,p,k,te,D,Le,F,qe="AdaLayerNorm",le,g,Z,Ce,J,Me="Norm layer modified to incorporate timestep embeddings.",me,v,S,oe,H,ke,R,Ve="AdaLayerNormZero",fe,_,I,Se,U,je="Norm layer adaptive layer norm zero (adaLN-Zero).",ce,b,E,re,q,Ee,B,Oe="AdaLayerNormSingle",ue,f,M,Pe,K,Fe="Norm layer adaptive layer norm single (adaLN-single).",Te,Q,Je='As proposed in PixArt-Alpha (see: <a href="https://arxiv.org/abs/2310.00426" rel="nofollow">https://arxiv.org/abs/2310.00426</a>; Section 2.3).',he,$,P,ne,V,Ge,W,Re="AdaGroupNorm",pe,y,j,De,X,Ue="GroupNorm layer modified to incorporate timestep embeddings.",ge;return T=new ae({}),D=new ae({}),Z=new ze({props:{name:"class diffusers.models.normalization.AdaLayerNorm",anchor:"diffusers.models.normalization.AdaLayerNorm",parameters:[{name:"embedding_dim",val:": int"},{name:"num_embeddings",val:": int"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNorm.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNorm.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/normalization.py#L28"}}),H=new ae({}),I=new ze({props:{name:"class diffusers.models.normalization.AdaLayerNormZero",anchor:"diffusers.models.normalization.AdaLayerNormZero",parameters:[{name:"embedding_dim",val:": int"},{name:"num_embeddings",val:": int"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormZero.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormZero.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/normalization.py#L51"}}),q=new ae({}),M=new ze({props:{name:"class diffusers.models.normalization.AdaLayerNormSingle",anchor:"diffusers.models.normalization.AdaLayerNormSingle",parameters:[{name:"embedding_dim",val:": int"},{name:"use_additional_conditions",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaLayerNormSingle.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaLayerNormSingle.use_additional_conditions",description:"<strong>use_additional_conditions</strong> (<code>bool</code>) &#x2014; To use additional conditions for normalization or not.",name:"use_additional_conditions"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/normalization.py#L82"}}),V=new ae({}),j=new ze({props:{name:"class diffusers.models.normalization.AdaGroupNorm",anchor:"diffusers.models.normalization.AdaGroupNorm",parameters:[{name:"embedding_dim",val:": int"},{name:"out_dim",val:": int"},{name:"num_groups",val:": int"},{name:"act_fn",val:": Optional = None"},{name:"eps",val:": float = 1e-05"}],parametersDescription:[{anchor:"diffusers.models.normalization.AdaGroupNorm.embedding_dim",description:"<strong>embedding_dim</strong> (<code>int</code>) &#x2014; The size of each embedding vector.",name:"embedding_dim"},{anchor:"diffusers.models.normalization.AdaGroupNorm.num_embeddings",description:"<strong>num_embeddings</strong> (<code>int</code>) &#x2014; The size of the embeddings dictionary.",name:"num_embeddings"},{anchor:"diffusers.models.normalization.AdaGroupNorm.num_groups",description:"<strong>num_groups</strong> (<code>int</code>) &#x2014; The number of groups to separate the channels into.",name:"num_groups"},{anchor:"diffusers.models.normalization.AdaGroupNorm.act_fn",description:"<strong>act_fn</strong> (<code>str</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014; The activation function to use.",name:"act_fn"},{anchor:"diffusers.models.normalization.AdaGroupNorm.eps",description:"<strong>eps</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-5</code>) &#x2014; The epsilon value to use for numerical stability.",name:"eps"}],source:"https://github.com/huggingface/diffusers/blob/v0.25.0/src/diffusers/models/normalization.py#L115"}}),{c(){u=o("meta"),ie=s(),h=o("h1"),C=o("a"),ee=o("span"),N(T.$$.fragment),we=s(),O=o("span"),O.textContent=He,se=s(),G=o("p"),G.textContent=Ie,de=s(),p=o("h2"),k=o("a"),te=o("span"),N(D.$$.fragment),Le=s(),F=o("span"),F.textContent=qe,le=s(),g=o("div"),N(Z.$$.fragment),Ce=s(),J=o("p"),J.textContent=Me,me=s(),v=o("h2"),S=o("a"),oe=o("span"),N(H.$$.fragment),ke=s(),R=o("span"),R.textContent=Ve,fe=s(),_=o("div"),N(I.$$.fragment),Se=s(),U=o("p"),U.textContent=je,ce=s(),b=o("h2"),E=o("a"),re=o("span"),N(q.$$.fragment),Ee=s(),B=o("span"),B.textContent=Oe,ue=s(),f=o("div"),N(M.$$.fragment),Pe=s(),K=o("p"),K.textContent=Fe,Te=s(),Q=o("p"),Q.innerHTML=Je,he=s(),$=o("h2"),P=o("a"),ne=o("span"),N(V.$$.fragment),Ge=s(),W=o("span"),W.textContent=Re,pe=s(),y=o("div"),N(j.$$.fragment),De=s(),X=o("p"),X.textContent=Ue,this.h()},l(e){const i=lt("svelte-1phssyn",document.head);u=r(i,"META",{name:!0,content:!0}),i.forEach(t),ie=d(e),h=r(e,"H1",{class:!0});var ve=m(h);C=r(ve,"A",{id:!0,class:!0,href:!0});var Be=m(C);ee=r(Be,"SPAN",{});var Ke=m(ee);x(T.$$.fragment,Ke),Ke.forEach(t),Be.forEach(t),we=d(ve),O=r(ve,"SPAN",{"data-svelte-h":!0}),c(O)!=="svelte-n23k4a"&&(O.textContent=He),ve.forEach(t),se=d(e),G=r(e,"P",{"data-svelte-h":!0}),c(G)!=="svelte-i4ltwe"&&(G.textContent=Ie),de=d(e),p=r(e,"H2",{class:!0});var _e=m(p);k=r(_e,"A",{id:!0,class:!0,href:!0});var Qe=m(k);te=r(Qe,"SPAN",{});var We=m(te);x(D.$$.fragment,We),We.forEach(t),Qe.forEach(t),Le=d(_e),F=r(_e,"SPAN",{"data-svelte-h":!0}),c(F)!=="svelte-15kqplo"&&(F.textContent=qe),_e.forEach(t),le=d(e),g=r(e,"DIV",{class:!0});var be=m(g);x(Z.$$.fragment,be),Ce=d(be),J=r(be,"P",{"data-svelte-h":!0}),c(J)!=="svelte-3m9blw"&&(J.textContent=Me),be.forEach(t),me=d(e),v=r(e,"H2",{class:!0});var $e=m(v);S=r($e,"A",{id:!0,class:!0,href:!0});var Xe=m(S);oe=r(Xe,"SPAN",{});var Ye=m(oe);x(H.$$.fragment,Ye),Ye.forEach(t),Xe.forEach(t),ke=d($e),R=r($e,"SPAN",{"data-svelte-h":!0}),c(R)!=="svelte-13daiza"&&(R.textContent=Ve),$e.forEach(t),fe=d(e),_=r(e,"DIV",{class:!0});var ye=m(_);x(I.$$.fragment,ye),Se=d(ye),U=r(ye,"P",{"data-svelte-h":!0}),c(U)!=="svelte-hxuhdq"&&(U.textContent=je),ye.forEach(t),ce=d(e),b=r(e,"H2",{class:!0});var Ne=m(b);E=r(Ne,"A",{id:!0,class:!0,href:!0});var et=m(E);re=r(et,"SPAN",{});var tt=m(re);x(q.$$.fragment,tt),tt.forEach(t),et.forEach(t),Ee=d(Ne),B=r(Ne,"SPAN",{"data-svelte-h":!0}),c(B)!=="svelte-1ekfhkk"&&(B.textContent=Oe),Ne.forEach(t),ue=d(e),f=r(e,"DIV",{class:!0});var Y=m(f);x(M.$$.fragment,Y),Pe=d(Y),K=r(Y,"P",{"data-svelte-h":!0}),c(K)!=="svelte-b3hofq"&&(K.textContent=Fe),Te=d(Y),Q=r(Y,"P",{"data-svelte-h":!0}),c(Q)!=="svelte-85nsxw"&&(Q.innerHTML=Je),Y.forEach(t),he=d(e),$=r(e,"H2",{class:!0});var xe=m($);P=r(xe,"A",{id:!0,class:!0,href:!0});var ot=m(P);ne=r(ot,"SPAN",{});var rt=m(ne);x(V.$$.fragment,rt),rt.forEach(t),ot.forEach(t),Ge=d(xe),W=r(xe,"SPAN",{"data-svelte-h":!0}),c(W)!=="svelte-1knkvt6"&&(W.textContent=Re),xe.forEach(t),pe=d(e),y=r(e,"DIV",{class:!0});var Ae=m(y);x(j.$$.fragment,Ae),De=d(Ae),X=r(Ae,"P",{"data-svelte-h":!0}),c(X)!=="svelte-gj85yz"&&(X.textContent=Ue),Ae.forEach(t),this.h()},h(){a(u,"name","hf:doc:metadata"),a(u,"content",JSON.stringify(ft)),a(C,"id","normalization-layers"),a(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(C,"href","#normalization-layers"),a(h,"class","relative group"),a(k,"id","diffusers.models.normalization.AdaLayerNorm"),a(k,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(k,"href","#diffusers.models.normalization.AdaLayerNorm"),a(p,"class","relative group"),a(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(S,"id","diffusers.models.normalization.AdaLayerNormZero"),a(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(S,"href","#diffusers.models.normalization.AdaLayerNormZero"),a(v,"class","relative group"),a(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(E,"id","diffusers.models.normalization.AdaLayerNormSingle"),a(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(E,"href","#diffusers.models.normalization.AdaLayerNormSingle"),a(b,"class","relative group"),a(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),a(P,"id","diffusers.models.normalization.AdaGroupNorm"),a(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),a(P,"href","#diffusers.models.normalization.AdaGroupNorm"),a($,"class","relative group"),a(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,i){n(document.head,u),l(e,ie,i),l(e,h,i),n(h,C),n(C,ee),A(T,ee,null),n(h,we),n(h,O),l(e,se,i),l(e,G,i),l(e,de,i),l(e,p,i),n(p,k),n(k,te),A(D,te,null),n(p,Le),n(p,F),l(e,le,i),l(e,g,i),A(Z,g,null),n(g,Ce),n(g,J),l(e,me,i),l(e,v,i),n(v,S),n(S,oe),A(H,oe,null),n(v,ke),n(v,R),l(e,fe,i),l(e,_,i),A(I,_,null),n(_,Se),n(_,U),l(e,ce,i),l(e,b,i),n(b,E),n(E,re),A(q,re,null),n(b,Ee),n(b,B),l(e,ue,i),l(e,f,i),A(M,f,null),n(f,Pe),n(f,K),n(f,Te),n(f,Q),l(e,he,i),l(e,$,i),n($,P),n(P,ne),A(V,ne,null),n($,Ge),n($,W),l(e,pe,i),l(e,y,i),A(j,y,null),n(y,De),n(y,X),ge=!0},p:at,i(e){ge||(z(T.$$.fragment,e),z(D.$$.fragment,e),z(Z.$$.fragment,e),z(H.$$.fragment,e),z(I.$$.fragment,e),z(q.$$.fragment,e),z(M.$$.fragment,e),z(V.$$.fragment,e),z(j.$$.fragment,e),ge=!0)},o(e){w(T.$$.fragment,e),w(D.$$.fragment,e),w(Z.$$.fragment,e),w(H.$$.fragment,e),w(I.$$.fragment,e),w(q.$$.fragment,e),w(M.$$.fragment,e),w(V.$$.fragment,e),w(j.$$.fragment,e),ge=!1},d(e){e&&(t(ie),t(h),t(se),t(G),t(de),t(p),t(le),t(g),t(me),t(v),t(fe),t(_),t(ce),t(b),t(ue),t(f),t(he),t($),t(pe),t(y)),t(u),L(T),L(D),L(Z),L(H),L(I),L(q),L(M),L(V),L(j)}}}const ft={local:"normalization-layers",sections:[{local:"diffusers.models.normalization.AdaLayerNorm",title:"AdaLayerNorm"},{local:"diffusers.models.normalization.AdaLayerNormZero",title:"AdaLayerNormZero"},{local:"diffusers.models.normalization.AdaLayerNormSingle",title:"AdaLayerNormSingle"},{local:"diffusers.models.normalization.AdaGroupNorm",title:"AdaGroupNorm"}],title:"Normalization layers"};function ct(Ze){return it(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class vt extends st{constructor(u){super(),dt(this,u,ct,mt,nt,{})}}export{vt as component};
